/*
 * Copyright 2023 Tadashi G. Takaoka
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "text_f3850.h"

namespace libasm {
namespace text {
namespace f3850 {
// clang-format off

const char TEXT_CPU_F3850[] PROGMEM = "F3850";
const char TEXT_CPU_3850[]  PROGMEM = "3850";

// const char TEXT_null[] PROGMEM = "";

// F3850
// const char TEXT_ADC[]  PROGMEM = "ADC";
// const char TEXT_AI[]   PROGMEM = "AI";
// const char TEXT_AM[]   PROGMEM = "AM";
const char TEXT_AMD[]  PROGMEM = "AMD";
const char TEXT_AS[]   PROGMEM = "AS";
const char TEXT_ASD[]  PROGMEM = "ASD";
const char TEXT_BC[]   PROGMEM = "BC";
const char TEXT_BF[]   PROGMEM = "BF";
// const char TEXT_BM[]   PROGMEM = "BM";
const char TEXT_BNC[]  PROGMEM = "BNC";
const char TEXT_BNO[]  PROGMEM = "BNO";
// const char TEXT_BNZ[]  PROGMEM = "BNZ";
// const char TEXT_BP[]   PROGMEM = "BP";
// const char TEXT_BR[]   PROGMEM = "BR";
const char TEXT_BR7[]  PROGMEM = "BR7";
// const char TEXT_BT[]   PROGMEM = "BT";
// const char TEXT_BZ[]   PROGMEM = "BZ";
// const char TEXT_CI[]   PROGMEM = "CI";
// const char TEXT_CLR[]  PROGMEM = "CLR";
// const char TEXT_CM[]   PROGMEM = "CM";
// const char TEXT_COM[]  PROGMEM = "COM";
const char TEXT_DCI[]  PROGMEM = "DCI";
// const char TEXT_DI[]   PROGMEM = "DI";
const char TEXT_DS[]   PROGMEM = "DS";
// const char TEXT_EI[]   PROGMEM = "EI";
// const char TEXT_IN[]   PROGMEM = "IN";
// const char TEXT_INC[]  PROGMEM = "INC";
// const char TEXT_INS[]  PROGMEM = "INS";
const char TEXT_JMP[]  PROGMEM = "JMP";
const char TEXT_LI[]   PROGMEM = "LI";
const char TEXT_LIS[]  PROGMEM = "LIS";
const char TEXT_LISL[] PROGMEM = "LISL";
const char TEXT_LISU[] PROGMEM = "LISU";
const char TEXT_LM[]   PROGMEM = "LM";
const char TEXT_LNK[]  PROGMEM = "LNK";
const char TEXT_LR[]   PROGMEM = "LR";
const char TEXT_NI[]   PROGMEM = "NI";
const char TEXT_NM[]   PROGMEM = "NM";
const char TEXT_NOP[]  PROGMEM = "NOP";
const char TEXT_NS[]   PROGMEM = "NS";
const char TEXT_OI[]   PROGMEM = "OI";
const char TEXT_OM[]   PROGMEM = "OM";
const char TEXT_OUT[]  PROGMEM = "OUT";
const char TEXT_OUTS[] PROGMEM = "OUTS";
const char TEXT_PI[]   PROGMEM = "PI";
const char TEXT_PK[]   PROGMEM = "PK";
const char TEXT_POP[]  PROGMEM = "POP";
const char TEXT_SL[]   PROGMEM = "SL";
const char TEXT_SR[]   PROGMEM = "SR";
const char TEXT_ST[]   PROGMEM = "ST";
const char TEXT_XDC[]  PROGMEM = "XDC";
const char TEXT_XI[]   PROGMEM = "XI";
const char TEXT_XM[]   PROGMEM = "XM";
const char TEXT_XS[]   PROGMEM = "XS";

// const char TEXT_REG_A[]  PROGMEM = "A";
const char TEXT_REG_DC[] PROGMEM = "DC";
// const char TEXT_REG_D[]  PROGMEM = "D";
// const char TEXT_REG_HL[] PROGMEM = "HL";
// const char TEXT_REG_H[]  PROGMEM = "H";
const char TEXT_REG_HU[] PROGMEM = "HU";
// const char TEXT_REG_I[]  PROGMEM = "I";
const char TEXT_REG_IS[] PROGMEM = "IS";
const char TEXT_REG_J[]  PROGMEM = "J";
const char TEXT_REG_KL[] PROGMEM = "KL";
const char TEXT_REG_K[]  PROGMEM = "K";
const char TEXT_REG_KU[] PROGMEM = "KU";
const char TEXT_REG_P0[] PROGMEM = "P0";
// const char TEXT_REG_P[]  PROGMEM = "P";
const char TEXT_REG_QL[] PROGMEM = "QL";
const char TEXT_REG_Q[]  PROGMEM = "Q";
const char TEXT_REG_QU[] PROGMEM = "QU";
// const char TEXT_REG_S[]  PROGMEM = "S";
// const char TEXT_REG_W[]  PROGMEM = "W";

// clang-format on
}  // namespace f3850
}  // namespace text
}  // namespace libasm

// Local Variables:
// mode: c++
// c-basic-offset: 4
// tab-width: 4
// End:
// vim: set ft=cpp et ts=4 sw=4:
